From 1646442d65eb1a5e412176c2e42cdb91f04d4f4c Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Jan 23 2018 16:41:37 +0000
Subject: [PATCH 38/48] migrate ModuleProfile to TreeObj


---

diff --git a/modulemd/profile.py b/modulemd/profile.py
index abd515a..275320e 100644
--- a/modulemd/profile.py
+++ b/modulemd/profile.py
@@ -22,27 +22,39 @@
 #
 # Written by Petr Šabata <contyk@redhat.com>
 
+from gi.repository import Modulemd
+
+from .legacy_wrappers import TreeObj, RPMsMixin
+
+
 supported_content = ("rpms",)
 
-from gi.repository import Modulemd
 
-class ModuleProfile(object):
+class ModuleProfile(TreeObj, RPMsMixin):
     """Class representing a particular module profile."""
 
-    def __init__(self, profile=None, name=None, parent=None):
+    tree_props = ('name',)
+
+    @property
+    def tree_identity(self):
+        return "profile<{}>".format(getattr(self, 'name', '<unknown>'))
+
+    def __init__(self, name=None, description=None, rpms=None, bound=False,
+                 parent=None):
         """Creates a new ModuleProfile instance."""
-        if profile:
-            if isinstance(profile, Modulemd.Profile):
-                self.profile = profile
-            else:
-                raise TypeError("Supplied value is not a profile")
-        else:
+        if parent:
             self.profile = Modulemd.Profile()
+        else:
+            assert not bound
 
-        if parent:
-            self.parent = parent
-        if name:
-            self.name = name
+        self.bound = False
+
+        super(ModuleProfile, self).__init__(rpms=rpms, parent=parent)
+
+        self.name = name
+        self.description = description
+        self.bound = bound
+        self._save_to_collection()
 
     def __repr__(self):
         return ("<ModuleProfile: name: {!r}, description: {!r},"
@@ -50,85 +62,76 @@ class ModuleProfile(object):
                                        sorted(self.rpms))
 
     def __bool__(self):
-        return True if (self.description or self.rpms) else False
+        return bool(super(ModuleProfile, self).__bool__() or self.description)
 
     __nonzero__ = __bool__
 
-    @property
-    def description(self):
-        """A string property representing a detailed description of the
-        profile."""
-        return self.profile.get_description()
+    @classmethod
+    def _new_from_native(cls, native_profile, bound=False, parent=None):
+        obj = cls(name=native_profile.get_name(),
+                   description=native_profile.get_description(),
+                   rpms=set(native_profile.get_rpms().get()), bound=bound,
+                   parent=parent)
+        return obj
 
-    @description.setter
-    def description(self, s):
-        if not isinstance(s, str):
-            raise TypeError("profile.description: data type not supported")
-        self.profile.set_description(s)
-        if hasattr(self, 'parent') and hasattr(self, 'name'):
-            profiles = self.parent.module.get_profiles()
-            profiles[self.name] = self.profile
-            self.parent.module.set_profiles(profiles)
-
-    @property
-    def rpms(self):
-        """A set of binary RPM packages included in this profile."""
-        return set(sorted(self.profile.get_rpms().get()))
-
-    @rpms.setter
-    def rpms(self, ss):
-        if not isinstance(ss, set):
-            raise TypeError("profile.rpms: data type not supported")
-        for v in ss:
-            if not isinstance(v, str):
-                raise TypeError("profile.rpms: data type not supported")
-
-        simpleset = Modulemd.SimpleSet()
-        simpleset.set(list(ss))
-        self.profile.set_rpms(simpleset)
-
-        if hasattr(self, 'parent') and hasattr(self, 'name'):
-            profiles = self.parent.module.get_profiles()
-            profiles[self.name] = self.profile
-            self.parent.module.set_profiles(profiles)
+    def _to_native(self):
+        obj = Modulemd.Profile()
+        obj.set_name(self.name)
+        obj.set_description(self.description)
 
-    def add_rpm(self, s):
-        """Adds a binary RPM package to the profile set.
+        if self.rpms is not None:
+            ss = Modulemd.SimpleSet()
+            ss.set(list(self.rpms))
+            obj.set_rpms(ss)
 
-        :param str s: Binary RPM package name
-        """
-        if not isinstance(s, str):
-            raise TypeError("profile.add_rpm: data type not supported")
-        simpleset = self.profile.get_rpms()
-        simpleset.add(s)
-        self.profile.set_rpms(simpleset)
+        return obj
 
-        if hasattr(self, 'parent') and hasattr(self, 'name'):
+    def _save_to_collection(self):
+        if self.parent and self.bound:
             profiles = self.parent.module.get_profiles()
-            profiles[self.name] = self.profile
+            profiles[self.name] = self._to_native()
             self.parent.module.set_profiles(profiles)
 
-    def del_rpm(self, s):
-        """Removes the supplied package name from the profile package set.
+    def get_rpm_set(self):
+        return self.profile.get_rpms()
 
-        :param str s: Binary RPM package name
-        """
-        if not isinstance(s, str):
-            raise TypeError("profile.del_rpm: data type not supported")
-        simpleset = self.profile.get_rpms()
-        simpleset.remove(s)
-        self.profile.set_rpms(simpleset)
+    def set_rpm_set(self, ss):
+        self.profile.set_rpms(ss)
+        self._save_to_collection()
 
-        if hasattr(self, 'parent') and hasattr(self, 'name'):
-            profiles = self.parent.module.get_profiles()
-            profiles[self.name] = self.profile
-            self.parent.module.set_profiles(profiles)
+    @property
+    def name(self):
+        """A string property representing the name of the profile."""
+        if self.parent:
+            return self.profile.get_name()
+        else:
+            return self._name
+
+    @name.setter
+    def name(self, s):
+        if s is not None and not isinstance(s, str):
+            raise TypeError("profile.name: data type not supported")
+        if self.parent:
+            self.profile.set_name(s)
+            self._save_to_collection()
+        else:
+            self._name = s
 
-    def clear_rpms(self):
-        """Clear the profile binary RPM package set."""
-        self.profile.set_rpms(Modulemd.SimpleSet())
+    @property
+    def description(self):
+        """A string property representing a detailed description of the
+        profile."""
+        if self.parent:
+            return self.profile.get_description()
+        else:
+            return self._description
 
-        if hasattr(self, 'parent') and hasattr(self, 'name'):
-            profiles = self.parent.module.get_profiles()
-            profiles[self.name] = self.profile
-            self.parent.module.set_profiles(profiles)
+    @description.setter
+    def description(self, s):
+        if s is not None and not isinstance(s, str):
+            raise TypeError("profile.description: data type not supported")
+        if self.parent:
+            self.profile.set_description(s)
+            self._save_to_collection()
+        else:
+            self._description = s

